"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const types = require("../../../utils/types.js");
const error = require("../../../utils/error.js");
const constants = require("./constants.js");
const Vue = require("vue");
const useCarouselItem = (props) => {
  const carouselContext = Vue.inject(constants.carouselContextKey);
  const instance = Vue.getCurrentInstance();
  if (!carouselContext) error.debugWarn(constants.CAROUSEL_ITEM_NAME, "usage: <el-carousel></el-carousel-item></el-carousel>");
  if (!instance) error.debugWarn(constants.CAROUSEL_ITEM_NAME, "compositional hook can only be invoked inside setups");
  const carouselItemRef = Vue.ref();
  const hover = Vue.ref(false);
  const translate = Vue.ref(0);
  const scale = Vue.ref(1);
  const active = Vue.ref(false);
  const ready = Vue.ref(false);
  const inStage = Vue.ref(false);
  const animating = Vue.ref(false);
  const { isCardType, isVertical, cardScale } = carouselContext;
  function processIndex(index, activeIndex, length) {
    const lastItemIndex = length - 1;
    const prevItemIndex = activeIndex - 1;
    const nextItemIndex = activeIndex + 1;
    const halfItemIndex = length / 2;
    if (activeIndex === 0 && index === lastItemIndex) return -1;
    else if (activeIndex === lastItemIndex && index === 0) return length;
    else if (index < prevItemIndex && activeIndex - index >= halfItemIndex) return length + 1;
    else if (index > nextItemIndex && index - activeIndex >= halfItemIndex) return -2;
    return index;
  }
  function calcCardTranslate(index, activeIndex) {
    var _a, _b;
    const parentWidth = Vue.unref(isVertical) ? ((_a = carouselContext.root.value) == null ? void 0 : _a.offsetHeight) || 0 : ((_b = carouselContext.root.value) == null ? void 0 : _b.offsetWidth) || 0;
    if (inStage.value) return parentWidth * ((2 - cardScale) * (index - activeIndex) + 1) / 4;
    else if (index < activeIndex) return -(1 + cardScale) * parentWidth / 4;
    else return (3 + cardScale) * parentWidth / 4;
  }
  function calcTranslate(index, activeIndex, isVertical2) {
    const rootEl = carouselContext.root.value;
    if (!rootEl) return 0;
    return ((isVertical2 ? rootEl.offsetHeight : rootEl.offsetWidth) || 0) * (index - activeIndex);
  }
  const translateItem = (index, activeIndex, oldIndex) => {
    const _isCardType = Vue.unref(isCardType);
    const carouselItemLength = carouselContext.items.value.length ?? NaN;
    const isActive = index === activeIndex;
    if (!_isCardType && !types.isUndefined(oldIndex)) animating.value = isActive || index === oldIndex;
    if (!isActive && carouselItemLength > 2 && carouselContext.loop) index = processIndex(index, activeIndex, carouselItemLength);
    const _isVertical = Vue.unref(isVertical);
    active.value = isActive;
    if (_isCardType) {
      inStage.value = Math.round(Math.abs(index - activeIndex)) <= 1;
      translate.value = calcCardTranslate(index, activeIndex);
      scale.value = Vue.unref(active) ? 1 : cardScale;
    } else translate.value = calcTranslate(index, activeIndex, _isVertical);
    ready.value = true;
    if (isActive && carouselItemRef.value) carouselContext.setContainerHeight(carouselItemRef.value.offsetHeight);
  };
  function handleItemClick() {
    if (carouselContext && Vue.unref(isCardType)) {
      const index = carouselContext.items.value.findIndex(({ uid }) => uid === instance.uid);
      carouselContext.setActiveItem(index);
    }
  }
  const carouselItemContext = {
    props,
    states: Vue.reactive({
      hover,
      translate,
      scale,
      active,
      ready,
      inStage,
      animating
    }),
    uid: instance.uid,
    getVnode: () => instance.vnode,
    translateItem
  };
  carouselContext.addItem(carouselItemContext);
  Vue.onBeforeUnmount(() => {
    carouselContext.removeItem(carouselItemContext);
  });
  return {
    carouselItemRef,
    active,
    animating,
    hover,
    inStage,
    isVertical,
    translate,
    isCardType,
    scale,
    ready,
    handleItemClick
  };
};
exports.useCarouselItem = useCarouselItem;
